IF EXISTS (SELECT * FROM dbo.SysObjects WHERE id = object_id(N'dbo.AUDIT_ins_ReservationConferenceLine') AND OBJECTPROPERTY(id, N'IsTrigger') = 1) DROP TRIGGER dbo.AUDIT_ins_ReservationConferenceLine 
GO
CREATE TRIGGER [dbo].[AUDIT_ins_ReservationConferenceLine]
ON [dbo].[ReservationConferenceLine] FOR INSERT NOT FOR REPLICATION AS
BEGIN
	

	DECLARE 
		@IDENTITY_SAVE				varchar(50),
		@AUDIT_LOG_TRANSACTION_ID		Int,
		@PRIM_KEY				nvarchar(4000),
		@ROWS_COUNT				int,
		@FK_UserIdNumber INT,
		@FK_CashBox INT,
		@ProgramPart SMALLINT,
		@TerminalName VARCHAR(50),
		@SystemDateStr VARCHAR(8),
		@SystemDateTime DATETIME

	SET NOCOUNT ON

	Select @ROWS_COUNT=count(*) from inserted
	Set @IDENTITY_SAVE = CAST(IsNull(@@IDENTITY,1) AS varchar(50))

    SELECT TOP 1 @FK_UserIdNumber = FK_UserIdNumber,
	@FK_CashBox = FK_CashBox,
	@ProgramPart = ProgramPart,
	@TerminalName = TerminalName
	FROM PersonnelLogInfo WITH (NOLOCK)
	WHERE spid = @@spid
	ORDER BY CreateDate DESC

	IF ISNULL(@FK_UserIdNumber, 0) = 0
	  SET @FK_UserIdNumber = 1
	IF ISNULL(@FK_CashBox, -1) <= 0
	  SET @FK_CashBox = -1
	IF ISNULL(@ProgramPart, -1) <= 0
	  SET @ProgramPart = 14 -- ppUnknown from SystemAll
	IF ISNULL(@TerminalName, '') = ''
	  SET @TerminalName = 'Unknown'	 

    SELECT @SystemDateStr = SystemDate FROM System WITH (NOLOCK) WHERE Number = 1
    SET @SystemDateTime = CONVERT(DATETIME, @SystemDateStr + ' ' + CONVERT(CHAR(8), CURRENT_TIMESTAMP, 108))

	INSERT INTO dbo.AUDIT_LOG_TRANSACTIONS
	(
		TABLE_NAME,
		TABLE_SCHEMA,
		AUDIT_ACTION_ID,
		HOST_NAME,
		APP_NAME,
		MODIFIED_BY,
		MODIFIED_DATE,
		AFFECTED_ROWS,
		FK_UserIdNumber,
		FK_CashBox,
		ProgramPart,
		TerminalName,
		RealDateTime
	)
	values(
		'ReservationConferenceLine',
		'dbo',
		2,	--	ACTION ID For INSERT
		CASE 
		  WHEN LEN(HOST_NAME()) < 1 THEN ' '
		  ELSE HOST_NAME()
		END,
		CASE 
		  WHEN LEN(APP_NAME()) < 1 THEN ' '
		  ELSE APP_NAME()
		END,
		SUSER_SNAME(),
		@SystemDateTime,
		@ROWS_COUNT,
		@FK_UserIdNumber,
		@FK_CashBox,
		@ProgramPart,
		@TerminalName,
		GETDATE()
	)
	
	Set @AUDIT_LOG_TRANSACTION_ID = SCOPE_IDENTITY()
	

	
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'ReservationConfLineNumber',
		CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[ReservationConfLineNumber] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'BookedConferenceRoomTypeNumber',
		CONVERT(nvarchar(4000), NEW.[BookedConferenceRoomTypeNumber], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[BookedConferenceRoomTypeNumber] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'ArrivalDate',
		CONVERT(nvarchar(4000), NEW.[ArrivalDate], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[ArrivalDate] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'ArrivalTime',
		CONVERT(nvarchar(4000), NEW.[ArrivalTime], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[ArrivalTime] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'DepartureDate',
		CONVERT(nvarchar(4000), NEW.[DepartureDate], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[DepartureDate] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'DepartureTime',
		CONVERT(nvarchar(4000), NEW.[DepartureTime], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[DepartureTime] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'ProductNumber',
		CONVERT(nvarchar(4000), NEW.[ProductNumber], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[ProductNumber] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'PackageNumber',
		CONVERT(nvarchar(4000), NEW.[PackageNumber], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[PackageNumber] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'Price',
		CONVERT(nvarchar(4000), NEW.[Price], 2),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[Price] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'TotalPrice',
		CONVERT(nvarchar(4000), NEW.[TotalPrice], 2),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[TotalPrice] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'PriceOverWritten',
		CONVERT(nvarchar(4000), NEW.[PriceOverWritten], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[PriceOverWritten] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'ConferenceRoomNumber',
		CONVERT(nvarchar(4000), NEW.[ConferenceRoomNumber], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[ConferenceRoomNumber] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'Adults',
		CONVERT(nvarchar(4000), NEW.[Adults], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[Adults] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'Children1',
		CONVERT(nvarchar(4000), NEW.[Children1], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[Children1] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'ReferenceNumber',
		CONVERT(nvarchar(4000), NEW.[ReferenceNumber], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[ReferenceNumber] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'TableBooking',
		CONVERT(nvarchar(4000), NEW.[TableBooking], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[TableBooking] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'TableStatus',
		CONVERT(nvarchar(4000), NEW.[TableStatus], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[TableStatus] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'GuestNo',
		CONVERT(nvarchar(4000), NEW.[GuestNo], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[GuestNo] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'Children2',
		CONVERT(nvarchar(4000), NEW.[Children2], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[Children2] IS NOT NULL
	
    
	INSERT INTO dbo.AUDIT_LOG_DATA
	(
		AUDIT_LOG_TRANSACTION_ID,
		PRIMARY_KEY_DATA,
		COL_NAME,
		NEW_VALUE_LONG,
		DATA_TYPE
		, KEY1
	)
	SELECT
		@AUDIT_LOG_TRANSACTION_ID,
		convert(nvarchar(1500), IsNull('[ReservationConfLineNumber]='+CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0), '[ReservationConfLineNumber] Is Null')),
		'PriceIsUserOverwritten',
		CONVERT(nvarchar(4000), NEW.[PriceIsUserOverwritten], 0),
		'A'
		, CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[ReservationConfLineNumber], 0))
	FROM inserted NEW
	
	  WHERE NEW.[PriceIsUserOverwritten] IS NOT NULL
	
    

	-- Lookup 
	

	-- Restore @@IDENTITY Value 
    DECLARE @maxprec AS varchar(2)
    SET @maxprec=CAST(@@MAX_PRECISION as varchar(2))
    EXEC('SELECT IDENTITY(decimal('+@maxprec+',0),'+@IDENTITY_SAVE+',1) id INTO #tmp')	
End
